﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace CS_W32_serial_ctrl
{
    public partial class Form1 : Form
    {
        SerialPort serialPort;
        public Form1()
        {
            InitializeComponent();
            comboBox1.Tag = SerialPort.GetPortNames();
            if (((string[])(comboBox1.Tag)).Length != 0)
            {
                for (int i = 0; i < ((string[])(comboBox1.Tag)).Length; i++)
                {
                    comboBox1.Items.Add(((string[])(comboBox1.Tag))[i]);

                }
                comboBox1.SelectedIndex = 0;
            }
            else
            {
                MessageBox.Show("V počítači není žádný PORT !!!");
            }
            serialPort = new SerialPort();
            serialPort.PinChanged += new SerialPinChangedEventHandler(serialPort_PinChanged);
            serialPort.DataReceived += new SerialDataReceivedEventHandler(serialPort_DataReceived);
        }

        void serialPort_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            serialPort.DiscardInBuffer();
        }

        void serialPort_PinChanged(object sender, SerialPinChangedEventArgs e)
        {
            checkBox_Cd.Checked = serialPort.CDHolding;
            checkBox_Cts.Checked = serialPort.CtsHolding;
            checkBox_Dsr.Checked = serialPort.DsrHolding;
        }

        private void butt_open_Click(object sender, EventArgs e)
        {
            try
            {
                if (serialPort.IsOpen != true)
                {
                    serialPort.PortName = ((string[])(comboBox1.Tag))[comboBox1.SelectedIndex];
                    //Podle čísla zvolené položky v comboboxu se přiřadí jméno dané položky na indexu v poli na proměnnou PortName.
                    //Pole se jmény jse ve vlastnosti Tag daného comboboxu.
                    serialPort.Open();
                    label_stav.Text = "Port " + serialPort.PortName + " otevren.";
                    butt_open.Text = "Close";
                }
                else
                {
                    serialPort.Close();
                    label_stav.Text = "Odpojeno";
                    butt_open.Text = "Open";
                }
            }
            catch (Exception ex)
            {

                MessageBox.Show(ex.Message);
            }
        }

        private void checkBox_Dtr_CheckedChanged(object sender, EventArgs e)
        {
            if (serialPort.IsOpen)
            {
                serialPort.DtrEnable = ((CheckBox)sender).Checked;
            }
        }

        private void checkBox_Rts_CheckedChanged(object sender, EventArgs e)
        {
            if (serialPort.IsOpen)
            {
                serialPort.RtsEnable = ((CheckBox)sender).Checked;
            }
        }








    }
}
